# p5.serialserver

## About

p5.serialserver is a [p5.js](https://p5js.org/) library that enables communication between your p5.js sketch and a serial enabled device, for example, an Arduino microcontroller.

This repository is part of the p5-serial project, for more info please visit [https://github.com/p5-serial/p5.serial.github.io/](https://github.com/p5-serial/p5.serial.github.io/).

## Installation

In order to follow these steps:

1. Connect an Arduino microcontroller or any other serial device to your computer.
2. Clone or download this repository.
3. Follow the steps to use either the Node.js version, or the Processing version.

### Node.js version

1. Open the terminal and navigate to this repository.
2. Install the dependencies with the command `npm install`.
3. Start the server with the command `node startserver.js`.

### Processing version

1. Install the latest Processing app, available at [https://processing.org/](https://processing.org/).
2. Navigate to the p5_serialserver/ folder on this repository and open the file p5_serialserver.pde with the Processing app.
3. Run this app and follow the instructions on it.

## Use

After running the server with Node.js or Processing, you can connect a client to the server.

For this you need to use the companion library p5.serialport available at [https://github.com/p5-serial/p5.serialport](https://github.com/p5-serial/p5.serialport), and follow the instructions over there.

## Contributions

Info about contributing is available at the main repository of this organization: [https://github.com/p5-serial/p5.serial.github.io/](https://github.com/p5-serial/p5.serial.github.io/).
